/*


Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package main

import (
	"flag"
	"os"
	"sync"
	"time"

	"k8s.io/apimachinery/pkg/runtime"
	utilruntime "k8s.io/apimachinery/pkg/util/runtime"
	clientgoscheme "k8s.io/client-go/kubernetes/scheme"
	_ "k8s.io/client-go/plugin/pkg/client/auth/gcp"
	ctrl "sigs.k8s.io/controller-runtime"
	"sigs.k8s.io/controller-runtime/pkg/event"
	"sigs.k8s.io/controller-runtime/pkg/healthz"
	"sigs.k8s.io/controller-runtime/pkg/log/zap"

	// for ConsoleLink. See https://sdk.operatorframework.io/docs/building-operators/golang/advanced-topics/#register-with-the-managers-scheme
	// Use go get github.com/openshift/api@release-4.6
	"github.com/go-co-op/gocron"
	consolev1 "github.com/openshift/api/console/v1"

	webservicesv1alpha1 "gitlab.cern.ch/paas-tools/operators/authz-operator/api/v1alpha1"
	"gitlab.cern.ch/paas-tools/operators/authz-operator/internal/apicache"
	"gitlab.cern.ch/paas-tools/operators/authz-operator/internal/authzapireq"
	"gitlab.cern.ch/paas-tools/operators/authz-operator/internal/controller"
	"gitlab.cern.ch/paas-tools/operators/authz-operator/internal/utils"
	// +kubebuilder:scaffold:imports
)

var (
	scheme   = runtime.NewScheme()
	setupLog = ctrl.Log.WithName("setup")
)

func init() {
	utilruntime.Must(clientgoscheme.AddToScheme(scheme))

	// for ConsoleLink. See https://sdk.operatorframework.io/docs/building-operators/golang/advanced-topics/#register-with-the-managers-scheme
	// Use go get github.com/openshift/api@release-4.6
	utilruntime.Must(consolev1.AddToScheme(scheme))

	utilruntime.Must(webservicesv1alpha1.AddToScheme(scheme))
	// +kubebuilder:scaffold:scheme
}

func main() {
	var metricsAddr string
	var enableLeaderElection bool
	var probeAddr string
	var namespace string
	// Settings for the Application Portal management link generated by the PojectLifecyclePolicy controller.
	// These are set globally because it is likely that if they change, we should update all existing links.
	var applicationPortalBaseUrl string
	var applicationPortalLinkText string
	var applicationCategoryUndefinedLinkText string
	var applicationCategoryTestLinkText string
	var applicationCategoryPersonalLinkText string
	var applicationCategoryOfficialLinkText string
	var lifecycleSyncPeriod string
	var applicationExportCron string

	flag.StringVar(&metricsAddr, "metrics-bind-address", ":8080", "The address the metric endpoint binds to.")
	flag.StringVar(&probeAddr, "health-probe-bind-address", ":8081", "The address the probe endpoint binds to.")
	flag.BoolVar(&enableLeaderElection, "leader-elect", false,
		"Enable leader election for controller manager. "+
			"Enabling this will ensure there is only one active controller manager.")
	flag.StringVar(&namespace, "namespace", "", "namespace to watch; defaults to all namespaces")

	flag.StringVar(&applicationPortalBaseUrl, "application-portal-base-url",
		"https://application-portal.web.cern.ch/manage/",
		"Base URL to generate a link to manage an application in the Application Portal. "+
			"The application ID will be appended to the base URL to generate to full URL.")
	flag.StringVar(&applicationPortalLinkText, "application-portal-link-text",
		"Manage roles and ownership for this application",
		"The text to show in the NamespaceDashboard ConsoleLink providing the general-purpose link from the OKD console "+
			"to the application's management page in the Application Portal.")
	flag.StringVar(&applicationCategoryUndefinedLinkText, "application-category-undefined-link-text",
		"This application's category is UNDEFINED - click here to set category",
		"The text to show in the NamespaceDashboard ConsoleLink providing info about the current application category "+
			"in the Application Portal when category is Undefined")
	flag.StringVar(&applicationCategoryTestLinkText, "application-category-test-link-text",
		"This application's category is TEST: it will be DELETED when owner leaves - click here to change",
		"The text to show in the NamespaceDashboard ConsoleLink providing info about the current application category "+
			"in the Application Portal when category is Test")
	flag.StringVar(&applicationCategoryPersonalLinkText, "application-category-personal-link-text",
		"This application's category is PERSONAL: it will be DELETED when owner leaves - click here to change",
		"The text to show in the NamespaceDashboard ConsoleLink providing info about the current application category "+
			"in the Application Portal when category is Personal")
	flag.StringVar(&applicationCategoryOfficialLinkText, "application-category-official-link-text",
		"This application's category is OFFICIAL: it will be REASSIGNED when owner leaves - click here to change",
		"The text to show in the NamespaceDashboard ConsoleLink providing info about the current application category "+
			"in the Application Portal when category is Official")

	flag.StringVar(&lifecycleSyncPeriod, "lifecycle-sync-period", "5m", "The period for lifecycle controller to check and re-syncing all applications (as a go duration)")
	flag.StringVar(&applicationExportCron, "application-export-cron", "36 17 * * *", "The cron schedule according to which miscellaneous information from the Application Portal is exported to the status of the ApplicationRegistration")

	opts := zap.Options{
		Development: true,
	}
	// allows to use standard zap command-line args to control verbosity
	// cf. https://sdk.operatorframework.io/docs/building-operators/golang/references/logging/
	opts.BindFlags(flag.CommandLine)

	flag.Parse()

	ctrl.SetLogger(zap.New(zap.UseFlagOptions(&opts)))

	mgr, err := ctrl.NewManager(ctrl.GetConfigOrDie(), ctrl.Options{
		Scheme:                 scheme,
		MetricsBindAddress:     metricsAddr,
		Port:                   9443,
		HealthProbeBindAddress: probeAddr,
		LeaderElection:         enableLeaderElection,
		LeaderElectionID:       "d0077095.cern.ch",
		// LeaderElectionReleaseOnCancel defines if the leader should step down voluntarily
		// when the Manager ends. This requires the binary to immediately end when the
		// Manager is stopped, otherwise, this setting is unsafe. Setting this significantly
		// speeds up voluntary leader transitions as the new leader don't have to wait
		// LeaseDuration time first.
		//
		// In the default scaffold provided, the program ends immediately after
		// the manager stops, so would be fine to enable this option. However,
		// if you are doing or is intended to do any operation such as perform cleanups
		// after the manager stops then its usage might be unsafe.
		// LeaderElectionReleaseOnCancel: true,
	})
	if err != nil {
		setupLog.Error(err, "unable to start manager")
		os.Exit(1)
	}
	// Initiate authzClient that will be used by controllers to access API
	// note: this is the "old" client and should not be used for new controllers
	authzClient, err := authzapireq.NewAuthzClient(ctrl.Log.WithName("AuthzAPIClient"))
	if err != nil {
		setupLog.Error(err, "can't create AuthzAPI client, incorrect configuration")
		os.Exit(1)
	}

	// authzApiCache avoids frequent lookups in the Authz API
	authzApiCache := apicache.NewApiCacheClient(ctrl.Log.WithName("AuthzAPICache"), authzClient)

	// new client, automatically generated from OpenAPI schema
	authzApiClient, err := utils.CreateAuthzApiClientFromEnv()
	if err != nil {
		setupLog.Error(err, "can't create AuthzAPIV1 client")
		os.Exit(1)
	}

	// This channel allows the background ApplicationRegistrationReconciler to receive requests to refresh status
	// of an ApplicationRegistration from the state in Auth API. These requests come from foreground ApplicationRegistrationReconciler
	// and also the LifecycleReconciler.
	appRefreshEvents := make(chan event.GenericEvent)

	// We need 2 instances of the ApplicationRegistrationReconciler:
	// - the foreground one processes regular Kubernetes resource events and applies changes to the Authz API.
	//   However it does not *read* state from the Authz API if the state in Kubernetes is consistent.
	//   This instance of the reconciler thus returns quickly in most cases.
	//   With every reconcile, it requests a refresh of the ApplicationRegistration state from the background reconciler
	// - the background one only processes requests to fully refresh an ApplicationRegistration's status
	//   received on AppStatusRefreshRequests
	// This is necessary because it takes too long to refresh status with each reconciliation
	// (controller SyncPeriod is 10h, and re-sync all AppReg on webeos would take >20m
	// during which time site creation from portal fails because it times out waiting for AppReg to be Created - cf. INC3490535)
	foregroundApplicationRegistrationReconciler := controller.ApplicationRegistrationReconciler{
		Client:                         mgr.GetClient(),
		Log:                            ctrl.Log.WithName("controllers").WithName("ApplicationRegistration"),
		Scheme:                         mgr.GetScheme(),
		Authz:                          authzClient,
		AuthzApiCache:                  authzApiCache,
		AppStatusRefreshRequests:       appRefreshEvents,      // instead tell background reconciler to do it.
		ReconcilerProcessingInProgress: make(map[string]bool), // Create a map to keep track of processed Requests
		ReconcilerSyncMutex:            &sync.Mutex{},         // Create a mutex to synchronize access to the map
	}
	// copy all fields to the backgroundApplicationRegistrationReconciler, we'll just call a different SetupWithManager method
	backgroundApplicationRegistrationReconciler := foregroundApplicationRegistrationReconciler
	if err = foregroundApplicationRegistrationReconciler.SetupWithManagerForForeground(mgr); err != nil {
		setupLog.Error(err, "unable to create foreground controller", "controller", "ApplicationRegistration")
		os.Exit(1)
	}
	if err = backgroundApplicationRegistrationReconciler.SetupWithManagerForBackground(mgr); err != nil {
		setupLog.Error(err, "unable to create background controller", "controller", "ApplicationRegistration")
		os.Exit(1)
	}

	// set up a scheduler to periodically create "virtual" reconciliation events for specific controllers
	scheduler := gocron.NewScheduler(time.UTC)

	// for lifecycle controller
	syncAllAppsEvents := make(chan event.GenericEvent)
	syncAllApps := func() {
		ctrl.Log.V(6).Info("gocron: generating periodic event to sync all apps")
		// dummy object
		event := event.GenericEvent{
			Object: &webservicesv1alpha1.ApplicationRegistration{},
		}
		syncAllAppsEvents <- event
	}
	job, err := scheduler.Every(lifecycleSyncPeriod).Do(syncAllApps)
	if err != nil {
		setupLog.Error(err, "unable to start periodic reconciliation job", "job", job)
		os.Exit(1)
	}

	// for applicationregistration export controller
	exportAllAppsEvents := make(chan event.GenericEvent)
	exportAllApps := func() {
		ctrl.Log.V(6).Info("gocron: generating virtual event to export all apps")
		// dummy object
		event := event.GenericEvent{
			Object: &webservicesv1alpha1.ApplicationRegistration{},
		}
		exportAllAppsEvents <- event
	}

	job, err = scheduler.Cron(applicationExportCron).Do(exportAllApps)
	if err != nil {
		setupLog.Error(err, "unable to start schduled reconciliation job", "job", job)
		os.Exit(1)
	}

	scheduler.StartAsync()

	if err = (&controller.LifecycleReconciler{
		Client:            mgr.GetClient(),
		Log:               ctrl.Log.WithName("controllers").WithName("Lifecycle"),
		Scheme:            mgr.GetScheme(),
		Authz:             authzClient,
		AuthzApiCache:     authzApiCache,
		LifecycleEvents:   appRefreshEvents,
		SyncAllAppsEvents: syncAllAppsEvents,
	}).SetupWithManager(mgr); err != nil {
		setupLog.Error(err, "unable to create controller", "controller", "Lifecycle")
		os.Exit(1)
	}

	if err = (&controller.ProjectLifecyclePolicyReconciler{
		Client:                               mgr.GetClient(),
		Log:                                  ctrl.Log.WithName("controllers").WithName("ProjectLifecyclePolicy"),
		Scheme:                               mgr.GetScheme(),
		ApplicationPortalBaseUrl:             applicationPortalBaseUrl,
		ApplicationPortalLinkText:            applicationPortalLinkText,
		ApplicationCategoryUndefinedLinkText: applicationCategoryUndefinedLinkText,
		ApplicationCategoryTestLinkText:      applicationCategoryTestLinkText,
		ApplicationCategoryPersonalLinkText:  applicationCategoryPersonalLinkText,
		ApplicationCategoryOfficialLinkText:  applicationCategoryOfficialLinkText,
	}).SetupWithManager(mgr); err != nil {
		setupLog.Error(err, "unable to create controller", "controller", "ProjectLifecyclePolicy")
		os.Exit(1)
	}

	if err = (&controller.BootstrapApplicationRoleReconciler{
		Client:        mgr.GetClient(),
		Log:           ctrl.Log.WithName("controllers").WithName("BootstrapApplicationRole"),
		Scheme:        mgr.GetScheme(),
		Authz:         authzClient,
		AuthzApiCache: authzApiCache,
	}).SetupWithManager(mgr); err != nil {
		setupLog.Error(err, "unable to create controller", "controller", "BootstrapApplicationRole")
		os.Exit(1)
	}

	if err = (&controller.ApplicationRegistrationExportReconciler{
		Client:              mgr.GetClient(),
		Log:                 ctrl.Log.WithName("controllers").WithName("ApplicationRegistrationExport"),
		Scheme:              mgr.GetScheme(),
		AuthzApiClient:      authzApiClient,
		ExportAllAppsEvents: exportAllAppsEvents,
	}).SetupWithManager(mgr); err != nil {
		setupLog.Error(err, "unable to create controller", "controller", "ApplicationRegistrationExport")
		os.Exit(1)
	}

	if err := mgr.AddHealthzCheck("healthz", healthz.Ping); err != nil {
		setupLog.Error(err, "unable to set up health check")
		os.Exit(1)
	}
	if err := mgr.AddReadyzCheck("readyz", healthz.Ping); err != nil {
		setupLog.Error(err, "unable to set up ready check")
		os.Exit(1)
	}

	setupLog.Info("starting manager")
	if err := mgr.Start(ctrl.SetupSignalHandler()); err != nil {
		setupLog.Error(err, "problem running manager")
		os.Exit(1)
	}
}
